/*
 * Résolution du problème Send + More = Money
 * 1° version du code du livre
  */
package Send_More_Money_V1;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solution;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;



public class Send_More_Money_V1 {
    public static void main(String[] args) {

    // Etape 1. Déclaration du modèle
    Model mon_modele = new Model("Send More Money");

    // Étape 2. Définition des variables et de leurs domaines respectifs.
    IntVar[] vars = new IntVar[8];
    vars[0] = mon_modele.intVar("S", 1, 9);
    vars[1] = mon_modele.intVar("E", 0, 9);
    vars[2] = mon_modele.intVar("N", 0, 9);
    vars[3] = mon_modele.intVar("D", 0, 9);
    vars[4] = mon_modele.intVar("M", 1, 9);
    vars[5] = mon_modele.intVar("0", 0, 9);
    vars[6] = mon_modele.intVar("R", 0, 9);
    vars[7] = mon_modele.intVar("Y", 0, 9);

    //Étape 3. Définition des contraintes.
    // (C2)
    int[] coeffs = new int[8]; 
    coeffs[0] = 1000;
    coeffs[1] = 91;
    coeffs[2] = -90;
    coeffs[3] = 1;
    coeffs[4] = -9000;
    coeffs[5] = -900;
    coeffs[6] = 10;
    coeffs[7] = -1;
    mon_modele.scalar(vars, coeffs,"=",0).post();

    // (C1)
    mon_modele.allDifferent(vars).post();

    //Étape 4. Résolution du problème
    Solver solv = mon_modele.getSolver();
    Solution solution = mon_modele.getSolver().findSolution();

    // Etape 5. Affichage de la solution
    if(solution != null){
            System.out.println(solution.toString());
    }
    else
            System.out.println("pas de solution");        
    } // fin main
} // fin class
    
    
    
  
